#!/bin/bash -xe
# script to use when the database is online - with connected users. Slower, but works.

cd "$(dirname "$0")" || exit

if [ "$(whoami)" != "root" ]
then
    echo "This command must be run as root"
    exit 1
fi

DBNAME=${1:-xtrf}

echo "select distinct 1 from system_configuration" | sudo -u postgres psql -v ON_ERROR_STOP=on "$DBNAME" -Atq

sudo -u postgres dropdb anonymize || true
sudo -u postgres createdb anonymize
echo "alter role postgres set temp_file_limit='500MB'" | sudo -u postgres psql anonymize
sudo -u postgres pg_dump --exclude-schema=audit -O -x "$DBNAME" | sed -r 's/^CREATE TABLE/CREATE UNLOGGED TABLE/' | sudo -u postgres psql anonymize

sudo -u postgres psql -v ON_ERROR_STOP=on -f 01_prepare.sql anonymize
sudo -u postgres psql -v ON_ERROR_STOP=on -f 02_anonymize.sql anonymize

sudo -u postgres pg_dump -O -x anonymize | sed -r 's/^CREATE UNLOGGED TABLE/CREATE TABLE/' | gzip > "anon_${DBNAME}-$(date +%Y-%m-%d).sql.gz"
echo "anon_${DBNAME}-$(date +%Y-%m-%d).sql.gz"
